package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.StatusPulang;
import com.jasamedika.medifirst2000.vo.StatusPulangVO;

@Component
public class StatusPulangConverter implements BaseVoConverter<StatusPulangVO, StatusPulang> {


	@Override
	public StatusPulang transferVOToModel(StatusPulangVO vo, StatusPulang model) {
		if (null == model)
			model = new StatusPulang();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, StatusPulang.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<StatusPulangVO> transferListOfModelToListOfVO(List<StatusPulang> models, List<StatusPulangVO> vos) {

		if (null == vos)
			vos = new ArrayList<StatusPulangVO>();

		if (null == models)
			return vos;

		for (StatusPulang statusPulang : models) {
			StatusPulangVO vo = new StatusPulangVO();
			vo=transferModelToVO(statusPulang, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public StatusPulangVO transferModelToVO(StatusPulang model, StatusPulangVO vo) {
		if (null == vo)
			vo = new StatusPulangVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
	        Gson gson = new Gson();

	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, StatusPulangVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	
	
	

}
